/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tarea.tema6;

import java.util.Scanner;
import tarea.tema6.comandos.Comando;
import tarea.tema6.comandos.ComandoAlta;
import tarea.tema6.comandos.ComandoAyuda;
import tarea.tema6.comandos.ComandoDetalle;
import tarea.tema6.comandos.ComandoLista;
import tarea.tema6.comandos.ComandoTerminar;
import tarea.tema6.comandos.ComandoTrabajo;
import tarea.tema6.contexto.Contexto;
import tarea.tema6.tipos.TIPO_COMANDO;

/**
 *
 * @author andreas
 */
public class Main {

    public static void main(String... args) {

        Contexto contexto = new Contexto();
        Comando comandoAlta = new ComandoAlta(contexto);
        Comando comandoLista = new ComandoLista(contexto);
        Comando comandoTerminar = new ComandoTerminar(contexto);
        Comando comandoAyuda = new ComandoAyuda(contexto);
        Comando comandoTrabajo = new ComandoTrabajo(contexto);
        Comando comandoDetalle = new ComandoDetalle(contexto);

        System.out.println("Teclee comandos, escriba AYUDA para opciones");

        Scanner scanner = null;
        String string = null;
        String[] split = null;
        try {

            scanner = new Scanner(System.in);
            contexto.setScanner(scanner);
            while (true) {

                string = scanner.nextLine();
                split = string.split(" ");

                TIPO_COMANDO tp = TIPO_COMANDO.findByCodigo(split[0]);
                if (null != tp) {
                    switch (tp) {
                        case AYUDA:
                            comandoAyuda.execute();
                            break;
                        case EXIT:
                            comandoTerminar.execute();
                            break;
                        case ALTA:
                            comandoAlta.execute();
                            break;
                        case LISTA:
                            comandoLista.setParameters(split);
                            comandoLista.execute();
                            break;
                        case TRABAJO:
                            comandoTrabajo.setParameters(split);
                            comandoTrabajo.execute();
                            break;
                        case DETALLE:
                            comandoDetalle.setParameters(split);
                            comandoDetalle.execute();
                            break;
                    }
                } else {
                    System.out.println("Ecriba AYUDA para opciones");
                }
            }

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (null != scanner) {
                scanner.close();
            }
        }

    }

}
