/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tarea.tema6.comandos;

import java.util.Scanner;
import tarea.tema6.area.Area;
import tarea.tema6.contexto.Contexto;
import tarea.tema6.empleado.*;
import tarea.tema6.tipos.TIPO_AREA;
import tarea.tema6.tipos.TIPO_CORTE;
import tarea.tema6.tipos.TIPO_PRENDA;

/**
 *
 * @author andreas
 */
public class ComandoAlta extends Comando {

    private String nombre = null;
    private TIPO_AREA tipoArea = null;
    private TIPO_PRENDA tipoPrenda = null;
    private TIPO_CORTE tipoCorte = null;
    private int numeroPrendas;
    private float metrosCortados;

    public ComandoAlta(Contexto contexto) {
        super(contexto);
    }

    @Override
    public void execute() {
        this.ingresarDatos();
        this.agregarEmpleado();
    }

    private void ingresarDatos() {

        Scanner scanner = contexto.getScanner();
        String string = null;

        try {

            System.out.print("Introduzca el nombre del empleado: ");
            nombre = scanner.nextLine();

            System.out.print("¿Area?: (C)orte, Con(F)eccion, (P)lanchado: ");
            string = scanner.nextLine();
            tipoArea = TIPO_AREA.findByCodigo(string.charAt(0));

        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    private void agregarEmpleado() {

        Empleado empleado = null;
        Area area = this.contexto.findByTipoArea(tipoArea);
        switch (tipoArea) {
            case CONFECCION:
                empleado = new EmpleadoConfeccion(nombre, area);
                area.agregarEmpleado(empleado);
                break;
            case PLANCHADO:
                empleado = new EmpleadoPlanchado(nombre, area);
                area.agregarEmpleado(empleado);
                break;
            case CORTE:
                empleado = new EmpleadoCorte(nombre, area);
                area.agregarEmpleado(empleado);

        }

    }

}
