/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tarea.tema6.comandos;

import java.util.List;
import tarea.tema6.area.Area;
import tarea.tema6.contexto.Contexto;
import tarea.tema6.empleado.Empleado;
import tarea.tema6.tipos.TIPO_AREA;
import tarea.tema6.trabajo.Trabajo;

/**
 *
 * @author andreas
 */
public class ComandoDetalle extends Comando {

    public ComandoDetalle(Contexto contexto) {
        super(contexto);
    }

    @Override
    public void execute() {
        if (this.getParameters().length == 2) {

            Empleado empleado = null;

            TIPO_AREA[] tiposArea = TIPO_AREA.values();
            Area area = null;
            for (TIPO_AREA tipoArea : tiposArea) {
                area = contexto.findByTipoArea(tipoArea);
                if (null != area) {

                    empleado = area.findByIdentificador(this.getParameters()[1]);
                    if (null != empleado) {
                        break;
                    }
                }
            }

            if (null != empleado) {
                List<Trabajo> trabajos = empleado.getTrabajos();
                float total = 0f;
                if(trabajos.isEmpty()) {
                 System.out.printf("%10s %10s %20s\n", new Object[]{"Trabajo","Puntuación", "Fecha y Hora"});
                 return;
                }
                for (Trabajo trabajo : trabajos) {
                    System.out.printf("%10s %10s %20s\n", new Object[]{trabajo.getTipoPrenda(), empleado.obtenerPuntos(trabajo), trabajo.getFecha()});
                }
            } else {
                System.out.println("Empleado no encontrado");
            }
        }
    }

}
