/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tarea.tema6.comandos;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import tarea.tema6.area.Area;
import tarea.tema6.contexto.Contexto;
import tarea.tema6.empleado.Empleado;
import tarea.tema6.tipos.TIPO_AREA;
import tarea.tema6.trabajo.Trabajo;

/**
 *
 * @author andreas
 */
public class ComandoLista extends Comando {

    public ComandoLista(Contexto contexto) {
        super(contexto);
    }

    @Override
    public void execute() {
        imprimirListado();
    }

    public void imprimirListado() {

        TIPO_AREA tipoArea = null;
        Area area = null;
        if (this.getParameters().length == 2) {
            char s = this.getParameters()[1].charAt(0);
            tipoArea = TIPO_AREA.findByCodigo(this.getParameters()[1].charAt(0));
            if (null == tipoArea) {
                System.out.println("Error: Area incorrecta");
                return;
            }

            area = contexto.getAreas().get(tipoArea);

            System.out.printf("%10s %5s %15s %10s\n", new Object[]{"Empleado", "Código", "Área", "Puntuación"});

            List<Empleado> empleados = area.getEmpleados();
            Iterator<Empleado> empleadosIterator = empleados.iterator();

            Empleado e = null;
            while (empleadosIterator.hasNext()) {
                e = empleadosIterator.next();
                List<Trabajo> trabajos = e.getTrabajos();
                if(trabajos.isEmpty()) {
                 System.out.printf("%10s %5s %15s %10s\n", new Object[]{e.getNombre(), e.getIdentificador(), e.getArea().getTipoArea(), "0"});
                 return;
                }
                for (Trabajo trabajo : trabajos) {
                    System.out.printf("%10s %5s %15s %10s\n", new Object[]{e.getNombre(), e.getIdentificador(), e.getArea().getTipoArea(), e.obtenerPuntos(trabajo)});
                }
            }

            System.out.println();

            return;
        }

        Map<TIPO_AREA, Area> areasMap = contexto.getAreas();
        Set<TIPO_AREA> keySet = areasMap.keySet();
        Iterator<TIPO_AREA> iterator = keySet.iterator();

        System.out.printf("%10s %5s %15s %10s\n", new Object[]{"Empleado", "Código", "Área", "Puntuación"});
        while (iterator.hasNext()) {
            area = areasMap.get(iterator.next());
            List<Empleado> empleados = area.getEmpleados();
            Iterator<Empleado> empleadosIterator = empleados.iterator();

            Empleado e = null;
            while (empleadosIterator.hasNext()) {
                e = empleadosIterator.next();
                List<Trabajo> trabajos = e.getTrabajos();
                if(trabajos.isEmpty()) {
                 System.out.printf("%10s %5s %15s %10s\n", new Object[]{e.getNombre(), e.getIdentificador(), e.getArea().getTipoArea(), "0"});
                 return;
                }
                for (Trabajo trabajo : trabajos) {
                    System.out.printf("%10s %5s %15s %10s\n", new Object[]{e.getNombre(), e.getIdentificador(), e.getArea().getTipoArea(), e.obtenerPuntos(trabajo)});
                }
            }
        }

        System.out.println();

    }

}
