/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tarea.tema6.comandos;

import java.util.Scanner;
import tarea.tema6.area.Area;
import tarea.tema6.contexto.Contexto;
import tarea.tema6.empleado.Empleado;
import tarea.tema6.tipos.TIPO_AREA;
import tarea.tema6.tipos.TIPO_CORTE;
import tarea.tema6.tipos.TIPO_PRENDA;
import tarea.tema6.trabajo.Trabajo;

/**
 *
 * @author andreas
 */
public class ComandoTrabajo extends Comando {

    public ComandoTrabajo(Contexto contexto) {
        super(contexto);
    }

    @Override
    public void execute() {
        if (this.getParameters().length == 2) {

            Empleado empleado = null;
            int numeroPrendas = 0;
            TIPO_CORTE tipoCorte = null;
            TIPO_PRENDA tipoPrenda = null;
            float metrosCortados = 0f;
            TIPO_AREA[] tiposArea = TIPO_AREA.values();
            Area area = null;
            for (TIPO_AREA tipoArea : tiposArea) {
                area = contexto.findByTipoArea(tipoArea);
                if (null != area) {

                    empleado = area.findByIdentificador(this.getParameters()[1]);
                    if (null != empleado) {
                        break;
                    }
                }
            }

            if (null != empleado) {
                Scanner scanner = contexto.getScanner();
                System.out.print("¿Tipo de prenda?: (C)amisa, Cami(S)eta, (P)antalon: ");
                String string = scanner.nextLine();
                tipoPrenda = TIPO_PRENDA.findByCodigo(string.charAt(0));
                while (null == tipoPrenda) {
                    System.out.println("Error: Prenda incorrecta");
                    System.out.print("¿Tipo de prenda?: (C)amisa, Cami(S)eta, (P)antalon: ");
                    string = scanner.nextLine();
                    tipoPrenda = TIPO_PRENDA.findByCodigo(string.charAt(0));
                };

                boolean correcto = false;
                switch (empleado.getArea().getTipoArea()) {
                    case CONFECCION:
                    case PLANCHADO:
                        System.out.print("¿Número de prendas?: ");
                        string = scanner.nextLine();

                        while (!correcto) {
                            try {
                                numeroPrendas = Integer.parseInt(string);
                                correcto = true;
                            } catch (Exception e) {
                                correcto = false;
                                System.out.println("Error: Valor incorrecto");
                                System.out.print("¿Número de prendas?: ");
                            }
                        }

                        break;
                    case CORTE:
                        System.out.print("¿Metros cortados?: ");
                        string = scanner.nextLine();

                        while (!correcto) {
                            try {
                                metrosCortados = Float.parseFloat(string);
                                correcto = true;
                            } catch (Exception e) {
                                correcto = false;
                                System.out.println("Error: Valor incorrecto");
                                System.out.print("¿Metros cortados?: ");
                            }
                        }

                        System.out.print("¿Tipo de corte?: (I)nformatico, (M)anual: ");
                        string = scanner.nextLine();
                        tipoCorte = TIPO_CORTE.findByCodigo(string.charAt(0));
                        while (null == tipoCorte) {
                            System.out.println("Error: Tipo de corte incorrecto");
                            System.out.print("¿Tipo de corte?: (I)nformatico, (M)anual: ");
                            string = scanner.nextLine();
                            tipoCorte = TIPO_CORTE.findByCodigo(string.charAt(0));
                        }
                        ;

                }
                Trabajo trabajo = new Trabajo();
                trabajo.setArea(area);
                trabajo.setMetrosCortados(metrosCortados);
                trabajo.setNumeroPrendas(numeroPrendas);
                trabajo.setTipoCorte(tipoCorte);
                trabajo.setTipoPrenda(tipoPrenda);

                empleado.agregarTrabajo(trabajo);

                System.out.println("Trabajo agregado");

            } else {
                System.out.println("Empleado no encontrado");
            }
        }
    }
}
