/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tarea.tema6.empleado;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import tarea.tema6.area.Area;
import tarea.tema6.trabajo.Trabajo;

/**
 *
 * @author andreas
 */
public abstract class Empleado {
    
    private String identificador;
    private String nombre;   
    private Area area;    
    private List<Trabajo> trabajos;
    
    public abstract float obtenerPuntos(Trabajo trabajo);

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public Area getArea() {
        return area;
    }

    public void setArea(Area area) {
        this.area = area;
    }
    
    public Empleado(String nombre, Area area) {
        this.nombre = nombre;
        this.area = area;    
        this.trabajos = new ArrayList<Trabajo>();        
    }

    public String getIdentificador() {
        return identificador;
    }

    protected void setIdentificador(String identificador) {
        this.identificador = identificador;
    }

    public void agregarTrabajo(Trabajo trabajo) {
    this.trabajos.add(trabajo);
    }

    public List<Trabajo> getTrabajos() {
        return trabajos;
    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 43 * hash + Objects.hashCode(this.identificador);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Empleado other = (Empleado) obj;
        if (!Objects.equals(this.identificador, other.identificador)) {
            return false;
        }
        return true;
    }
    
    
}
